<template>
  <span>{{ viewNumber }}</span>
</template>

<script>
export default {
  data() {
    return {
      viewNumber: 0,
      easeOutQuad: (t) => t * (2 - t),
    };
  },
  props: {
    number: {
      default: 0,
    },
    duration: {
      type: Number,
      default: 1000,
    },
    frameDuration: {
      type: Number,
      default: 1000 / 60, //60 frames per second
    },
  },
  computed: {
    totalFrames() {
      if (this.duration && this.frameDuration)
        return Math.round(this.duration / this.frameDuration);
      else return 0;
    },
  },
  watch: {
    number(newNumber) {
      if (newNumber) this.animateCountUp(newNumber);
    },
  },
  created() {
    this.viewNumber = this.number;
  },
  methods: {
    animateCountUp(newNumber) {
      let frame = 0;

      // Start the animation running 60 times per second
      const counter = setInterval(() => {
        frame++;
        // Calculate our progress as a value between 0 and 1
        // Pass that value to our easing function to get our
        // progress on a curve
        const progress = this.easeOutQuad(frame / this.totalFrames);
        // Use the progress value to calculate the current count
        const currentCount = Math.round(newNumber * progress);

        // If the current count has changed, update the element
        if (this.viewNumber !== currentCount) {
          this.viewNumber = currentCount;
        }

        // If we’ve reached our last frame, stop the animation
        if (frame === this.totalFrames) {
          clearInterval(counter);
        }
      }, this.frameDuration);
    },
  },
};
</script>

<style>
</style>